
10     '  Program to demonstrate the Fast Fourier transform ( June 17, 1982 ) 
20     '  It was written in  Microsoft Basic  using the  WordStar text editor
30     '  and was run on the Zentec microcomputer  using  the  CP/M operating
40     '  system.  Largest possible transform = 128 points.  Time = 161 sec.
50     '  BY : SEAN O'CONNOR
60     '  The program can transform any number of points between  2 and  Max%
70     '  inclusive.  To increase the maximum size of the transform, take the
80     '  following steps: 
90     '
100    '  1.  Increase the value of Max%    ( It must be a power of 2. )
110    '
120    '  2.  Increase the array dimensions. The values are given below in 
130    '      the dimension statements in terms of Max%. 
140    '
150    '  3.  Store additional values in the arrays ExponentIncrementReal
160    '      and ExponentIncrementImag.
170    '
180    '  For  example, to increase the maximum transform  size  to  256,
190    '  set  Max% = 256, change the  array dimensions to 255, 255, 255,
200    '  127, 7, and 7 respectively, and add the values Cos( Pi / 2^7 ), 
210    '  -Sin( Pi / 2^7 ) to the end of the exponent increment table.
220    ' 
230       MAX% = 128 
240    '                                         Maximum array dimensions :
250       DIM   XREAL#( 127 )                         ' Max% - 1
260       DIM   XIMAG#( 127 )                         ' Max% - 1
270       DIM   EXCHANGE%( 127 )                      ' Max% - 1
280       DIM   GROUPSTARTLOCATION%( 63 )             ' Max% / 2  - 1
290       DIM   EXPONENTINCREMENTREAL#( 6 )           ' Logbase2( Max% ) - 1
300       DIM   EXPONENTINCREMENTIMAG#( 6 )           ' Logbase2( Max% ) - 1 
310    '
320       PRINT "Fast Fourier Transform Program"
322 OPEN "O",#1,"B:FFTDATA"	:	OPEN "O",#2,"B:FFTRES"
330       PRINT 
340   '
350      PRINT
360      INPUT "Do you wish to enter data ( Y or N ) "; A$
370      A$ = LEFT$( A$, 1 )
380   '
390      IF       A$ = "N" OR A$ = "n" THEN    GOTO 600                                 ELSE IF  A$ = "Y" OR A$ = "y" THEN    GOTO 410                                 ELSE     PRINT "Please type Y or N only."  : GOTO 350

400   '
410      PRINT
420      INPUT "How many points are in the transform "; N%
430   '   
440      IF N% < 2 THEN                                                                    PRINT "There must be at least 2 points."            : GOTO 410
450   ' 
460      IF N% > MAX% THEN                                                                  PRINT "The number of points must not exceed "; MAX% : GOTO 410
470   '
480      GAMMA = LOG( N% ) / LOG( 2 )
490   '
500      IF ABS( INT( GAMMA ) - GAMMA ) > .001 THEN                                         PRINT "The number of points must be a power of 2."  : GOTO 410
510   '
520      PRINT
522 PRINT #1,"DATA COEFFICIENTS"
530      FOR I% = 0 TO N% - 1
540          PRINT "Point "; I% + 1 ,
550          INPUT "Real part "; XREAL#( I% )
560          INPUT "              Imag part "; XIMAG#( I% )
562 PRINT #1,I%+1,XREAL#(I%)
570          PRINT
580      NEXT I%
590   '
600      PRINT
610      INPUT "Direction of the FFT ( f for forward, i for inverse ) "; B$
620      B$ = LEFT$( B$, 1 )
630   '
640      IF       B$ = "F" OR B$ = "f" THEN    DIRECTION% =  1                          ELSE IF  B$ = "I" OR B$ = "i" THEN    DIRECTION% = -1                          ELSE     PRINT "Please type I or F only."  : GOTO 600
650   '
660      IF ( A$ = "N" OR A$ = "n" ) AND ( C$ = "Y" OR C$ = "y" ) THEN                       GOSUB 2210                                                                 ELSE GOSUB 820
670   '
680      PRINT
690      PRINT "The Fourier coefficients: "
700      PRINT
702 PRINT #1,"TRANSFORM COEEFICIENTS"
710      FOR I% = 0 TO N% - 1
720          PRINT "c ( "; I% ;" ) = "; XREAL#( I% );" + I * "; XIMAG#( I% ) 
722 PRINT #2,I%+1,XREAL#(I%)
730      NEXT I%
740   '
750      PRINT
760      INPUT "Do you wish to continue ( Y or N ) "; C$
770      C$ = LEFT$( C$, 1 )
780   '
790      IF       C$ = "Y" OR C$ = "y" THEN    GOTO 350                                 ELSE IF  C$ = "N" OR C$ = "n" THEN    GOTO 810                                 ELSE     PRINT "Please type Y or N only." : GOTO 750
800   '
810      STOP 
820   '
830   '--------- Fast Fourier Transform for N = ( 2 ^ Gamma ) points --------
840   '
850   ' Input :   (1) The number of points N%
860   '           (2) The complex numbers ( xReal#[ m ] + i * xImag#[ m ] )
870   '               for m = 0,1, . . ., N% - 1 
880   '           (3) The direction of the Fourier Transform :
890   '                   Direction% =   1  Forward transform
900   '                                 -1  Inverse transform  
910   '   
920   ' Output :  (1) The discrete Fourier coefficients c[ k ]  
930   '               for k = 0,1, . . . , N - 1  defined by
940   '
950   '                 N - 1
960   '                 ----
970   '             1   \              - Direction% * 2 * Pi * i * m * k / N 
980   ' c[ k ] =   ___  /    x[ m ] * e     
990   '          \/ N   ----
1000   '                 m = 0  
1010   '
1020   '               These coefficients are returned in the same arrays as
1030   '               xReal# and xImag#.  The original data is overwritten.
1040   '
1050   '           (2) Bad values for N or Direction% cause the procedure
1060   '               to return immediately and set an error flag: 
1070   '
1080   '              Flag%   =    0   No errors
1090   '                           1   N < 2
1100   '                           2   N > Max%
1110   '                           3   N was not a power of 2
1120   '                           4   Direction% was not 1 or -1
1130   '
1140   '  Calling sequence:   N% =  NUMBER OF POINTS IN THE TRANSFORM
1150   '                      For i% = 0 to N%-1
1160   '                          xReal#( i ) = REAL PART OF ITH POINT
1170   '                          xImag#( i ) = IMAGINARY PART OF ITH POINT
1180   '                      Next i% 
1190   '                      Direction% =  1 (FORWARD) OR -1 (INVERSE) 
1200   '                      Gosub 200
1210   '                      If Flag% > 0 then ERROR RECOVERY
1220   '                      For i% = 0 to N%-1
1230   '                          Print "Fourier coeff"; xReal#(i); xImag#(i)
1240   '                      Next i%
1250   '
1260   '  As long as N% does not change, succeeding calls to the  FFT may
1270   '  use  Gosub 800.  The  first call  ( Gosub 200 )  has  built the 
1280   '  tables.  Later calls may use the values already computed, since
1290   '  they depend only on the value of N%.
1300   ' 
1310   '---------------------------------------------------------------------
1320   '
1330   '--------- Calculate parameters and check for errors -----------------
1340   '
1350      FLAG% = 0
1360   '
1370      IF N% < 2 THEN                  FLAG% = 1 : RETURN
1380   '
1390      IF N% > MAX% THEN               FLAG% = 2 : RETURN
1400   '
1410      IF ABS( DIRECTION% ) <> 1 THEN  FLAG% = 4 : RETURN
1420   '
1430   '  Compute Logbase 2 of N.  If the  
1440   '  fractional  part  is  non-zero,  
1450   '  then  N is  not  a  power of 2.
1460   '
1470      GAMMA = LOG( N% ) / LOG( 2 )
1480   '
1490      IF ABS( INT( GAMMA ) - GAMMA ) > .001 THEN   FLAG% = 3 : RETURN
1500   '
1510      GAMMA% = INT( GAMMA + .1 )       ' Round to an integer
1520   '
1530      PI# = 3.141592653589794#
1540   '
1550   '--------- Set up tables of pre-computed quantities -------------------
1560   '                   
1570   '--------- Construct bit reversed numbers -----------------------------
1580   '
1590      FOR K% = 0 TO N% - 1
1600          EXCHANGE%( K% ) = 0
1610      NEXT K%
1620   '
1630      PTR% = 0
1640      BLOCKSIZE% = 1
1650      TERM% = N% \ 2
1660   '
1670          FOR J% = 1 TO BLOCKSIZE%
1680             PTR% = PTR% + 1
1690             EXCHANGE%( PTR% ) = TERM% + EXCHANGE%( PTR% - BLOCKSIZE% )
1700          NEXT J%
1710   '
1720          TERM% = TERM% \ 2
1730          BLOCKSIZE% = 2 * BLOCKSIZE%
1740   '
1750      IF TERM% >= 1 GOTO 1670
1760   '
1770   '
1780      FOR I% = 0 TO N% \ 2 - 1
1790          GROUPSTARTLOCATION%( I% ) = EXCHANGE%( I% )
1800      NEXT I%
1810   '--------- Set up group starting locations ----------------------------
1820   '
1830   '--------- Set up Exchange flag array ---------------------------------
1840   '
1850     FOR K% = 0 TO N% - 1
1860         IF EXCHANGE%( K% ) < K% THEN       EXCHANGE%( K% ) = - 1                       ELSE IF EXCHANGE%( K% ) = K% THEN  EXCHANGE%( K% ) =   0             
1870     NEXT K%
1880   '
1890   '--------- Set up table of exponent starting values -------------------
1900   '
1910   ' The values generated by the following algorithm are to be stored 
1920   ' in the ExponentIncrement arrays:
1930   '
1940   ' For i% = 0 to Logbase2( Max% ) - 1
1950   '       Angle# = Pi# / ( 2 ^ i% )
1960   '       ExponentIncrementReal#( i% ) =   Cos( Angle# )
1970   '       ExponentIncrementImag#( i% ) = - Sin( Angle# ) 
1980   ' Next i%
1990   '
2000   ' 
2010     EXPONENTINCREMENTREAL#( 0 ) = - 1
2020     EXPONENTINCREMENTIMAG#( 0 ) =   0
2030   '  
2040     EXPONENTINCREMENTREAL#( 1 ) =   0
2050     EXPONENTINCREMENTIMAG#( 1 ) = - 1
2060   '
2070     EXPONENTINCREMENTREAL#( 2 ) =   .7071067811865476#
2080     EXPONENTINCREMENTIMAG#( 2 ) = - .7071067811865478#
2090   '
2100     EXPONENTINCREMENTREAL#( 3 ) =   .9238795325112869#
2110     EXPONENTINCREMENTIMAG#( 3 ) = - .38268343236509#
2120   '
2130     EXPONENTINCREMENTREAL#( 4 ) =   .9807852804032306#
2140     EXPONENTINCREMENTIMAG#( 4 ) = - .1950903220161283#
2150   '
2160     EXPONENTINCREMENTREAL#( 5 ) =   .995184726672197#
2170     EXPONENTINCREMENTIMAG#( 5 ) = - .09801714032956063#
2180   '
2190     EXPONENTINCREMENTREAL#( 6 ) =   .9987954562051726#
2200     EXPONENTINCREMENTIMAG#( 6 ) = - .04906767432741804#
2210   '
2220   '--------- This is the Fast Fourier Transform proper ------------------
2230   '
2240      PAIRSEPARATION% = N% \ 2
2250      NUMBEROFGROUPS% = 1
2260   '
2270      FOR COLUMN% = 1 TO GAMMA%
2280   '
2290          EXPONENTREAL# = EXPONENTINCREMENTREAL#( COLUMN% - 1 )
2300          EXPONENTIMAG# = EXPONENTINCREMENTIMAG#( COLUMN% - 1 ) * DIRECTION%
2310   '
2320          INCREMENTREAL# = EXPONENTREAL#
2330          INCREMENTIMAG# = EXPONENTIMAG#
2340   '
2350   '      ---------- Do the first group ----------------------------------
2360   '
2370          FOR K% = 0 TO PAIRSEPARATION% - 1
2380   '
2390              OFFSET% = K% + PAIRSEPARATION%
2400   '
2410              TEMPREAL# = XREAL#( K% ) + XREAL#( OFFSET% )
2420              TEMPIMAG# = XIMAG#( K% ) + XIMAG#( OFFSET% )
2430   '          
2440              XREAL#( OFFSET% ) = XREAL#( K% ) - XREAL#( OFFSET% )
2450              XIMAG#( OFFSET% ) = XIMAG#( K% ) - XIMAG#( OFFSET% )
2460   '
2470              XREAL#( K% ) = TEMPREAL#
2480              XIMAG#( K% ) = TEMPIMAG#
2490   '
2500          NEXT K%
2510  '
2520  '      ---------- Do the remaining groups -----------------------------
2530  '
2540         FOR GROUP% = 2 TO NUMBEROFGROUPS%
2550  '
2560             STARTOFAGROUP% = GROUPSTARTLOCATION%( GROUP% - 1 )
2570             LASTBUTTERFLYPOSITION% = STARTOFAGROUP% + PAIRSEPARATION% - 1
2580  '
2590             FOR K% = STARTOFAGROUP% TO LASTBUTTERFLYPOSITION%
2600  '
2610                 OFFSET% = K% + PAIRSEPARATION%
2620  '
2630                 TERMREAL# = XREAL#( OFFSET% ) * EXPONENTREAL#                                            - XIMAG#( OFFSET% ) * EXPONENTIMAG#
2640  '
2650                 TERMIMAG# = XREAL#( OFFSET% ) * EXPONENTIMAG#                                            + XIMAG#( OFFSET% ) * EXPONENTREAL#
2660  '          
2670                 TEMPREAL# = XREAL#( K% ) + TERMREAL#
2680                 TEMPIMAG# = XIMAG#( K% ) + TERMIMAG#
2690  '
2700                 XREAL#( OFFSET% ) = XREAL#( K% ) - TERMREAL#
2710                 XIMAG#( OFFSET% ) = XIMAG#( K% ) - TERMIMAG#
2720  '
2730                 XREAL#( K% ) = TEMPREAL#
2740                 XIMAG#( K% ) = TEMPIMAG#
2750  '
2760             NEXT K%
2770  '
2780          TEMPREAL# =     EXPONENTREAL# * INCREMENTREAL#                                               - EXPONENTIMAG# * INCREMENTIMAG#       
2790  '
2800          EXPONENTIMAG# = EXPONENTREAL# * INCREMENTIMAG#                                               + EXPONENTIMAG# * INCREMENTREAL#
2810  ' 
2820          EXPONENTREAL# = TEMPREAL#
2830  '
2840          NEXT GROUP%
2850  '        
2860     PAIRSEPARATION% = PAIRSEPARATION% \ 2
2870     NUMBEROFGROUPS% = NUMBEROFGROUPS% * 2
2880  '
2890     NEXT COLUMN%
2900  '  
2910  '--------- Permute and normalize the results of the computations ------
2920  '
2930  '  Compute the double  precision square
2940  '  root  of  N%  using  2 iterations of
2950  '  Newton's method.  The starting value
2960  '  is the single precision square root.
2970  '     
2980     NORMALIZER# = SQR( N% )
2990     NORMALIZER# = ( NORMALIZER# + N% / NORMALIZER# ) / 2
3000     NORMALIZER# = ( NORMALIZER# + N% / NORMALIZER# ) / 2
3010     NORMALIZER# = 1 / NORMALIZER#
3020  '
3030     FOR I% = 0 TO N% - 1
3040         EXCH% = EXCHANGE%( I% )
3050  ' 
3060         IF EXCH%  = - 1 THEN GOTO 3180
3070  '  
3080         IF EXCH% = 0 THEN                                                                   XREAL#( I% ) = XREAL#( I% ) * NORMALIZER# :                                    XIMAG#( I% ) = XIMAG#( I% ) * NORMALIZER# :  GOTO 3180
3090  '  
3100         TEMPREAL# =        XREAL#( I% ) 
3110         TEMPIMAG# =        XIMAG#( I% )
3120  '
3130         XREAL#( I% ) =     XREAL#( EXCH% ) * NORMALIZER#
3140         XIMAG#( I% ) =     XIMAG#( EXCH% ) * NORMALIZER#
3150  '
3160         XREAL#( EXCH% ) =  TEMPREAL# * NORMALIZER#
3170         XIMAG#( EXCH% ) =  TEMPIMAG# * NORMALIZER#
3180     NEXT I%
3190  '
3200  '--------- End of the FFT ---------------------------------------------
3210  '
3220     RETURN
3230     END
